#ifndef _DIJK_H_
#define _DIJK_H_

#define DIJK_MAXP 200 /* max number of points */
typedef struct _dijk_t
{
    int start, goal; /* start point and goal point (starts with 1)*/
    float wt[DIJK_MAXP][DIJK_MAXP];       /* weights table  [i][j] */
} dijk_t;

void dijk_init( dijk_t *d);
void dijk_add_mutual_path( dijk_t *d, int i, int j, float cost );
void dijk_add_path( dijk_t *d, int i, int j, float cost );
void dijk_get_route( dijk_t *d, int s_i, int g_i, int *ans, int anslen,
                     float *cost );
void dijk_test(void);


#endif
