#define _FRAME_CPP_
#include <windows.h>
#include <stdio.h>
#include "frame.h"
#include "common.h"

#define FRAME_FREQ 30


LONGLONG count_nextrefresh;  // tbVJEg
LONGLONG count_per_frame;    // 1̃JEg
LONGLONG frame_sec_start;

/*------------------------------------------------
  Performance Counter ̏
  ------------------------------------------------*/
BOOL frame_initialize(void)
{
    LONGLONG count_current;      // ݂̃JEg

    if( QueryPerformanceFrequency((LARGE_INTEGER *)&freq_perfcount)) {
        QueryPerformanceCounter((LARGE_INTEGER *)&count_current);
        count_per_frame = freq_perfcount / (LONGLONG)FRAME_FREQ;
        count_nextrefresh = count_current + count_per_frame;
    }
    else {
        return FALSE;
    }

    return TRUE;
}
/*------------------------------------------------
  ĕ`悷ׂԂ TRUE Ԃ
  ------------------------------------------------*/
BOOL frame_is_refresh_time(void)
{
    LONGLONG count_current;

    QueryPerformanceCounter((LARGE_INTEGER *)&count_current);
    
    if( count_current <= count_nextrefresh) {
        return TRUE;
    }
    else {
        count_nextrefresh += count_per_frame;
        return FALSE;
    }
}
/* -------------------------------------------------------------------------
 * ̕`掞ԂZbgB
 * -------------------------------------------------------------------------*/
void frame_set_next_refresh( void)
{
    count_nextrefresh += count_per_frame;
}    
/* -------------------------------------------------------------------------
 * ̕`掞ԂZbgB`悵ȂǂɕKvB
 * -------------------------------------------------------------------------*/
void frame_reset( void)
{
    LONGLONG count_current;
    QueryPerformanceCounter((LARGE_INTEGER *)&count_current);
    count_nextrefresh = count_current + count_per_frame;
}
/* -------------------------------------------------------------------------
 * t[̍ŏ̎ԂZbgB
 * -------------------------------------------------------------------------*/
void frame_set_sec_start( void)
{
    QueryPerformanceCounter((LARGE_INTEGER *)&frame_sec_start);
}    
/* -------------------------------------------------------------------------
 * ̕`掞Ԃ܂ŃX[vB
 * -------------------------------------------------------------------------*/
void frame_sleep( void)
{
    LONGLONG count_current;
    while( 1) {
        QueryPerformanceCounter((LARGE_INTEGER *)&count_current);
        if( count_current < count_nextrefresh) {
            Sleep( 1);
        }
        else {
            break;
        }
    }
    
}    
/* -------------------------------------------------------------------------
 * t[[gZoB
 * -------------------------------------------------------------------------*/
void frame_calc_frame_rate( void)
{
    LONGLONG count_current;
    QueryPerformanceCounter((LARGE_INTEGER *)&count_current);
    if( count_current >= frame_sec_start + freq_perfcount) {
        frame_rate = frame_count;
        frame_count = 0;
        frame_sec_start = count_current;
    }
}    
