#ifndef _INCOMING_H_
#define _INCOMING_H_

#include "lumiproto_cli.h"

typedef struct _incoming_list_t {
    unsigned int serial;
    float longitude, latitude;
    long recv_time;
    struct _incoming_list_t *next;
    char msg[LUMIPROTO_MSG_MAX+1];
    char name[LUMIPROTO_NAME_MAX+1];
}incoming_list_t;


extern int incoming_msg_num;

int incoming_init( void);
int incoming_append( unsigned int serial, float lo, float la, char *msg, char *name);
int incoming_create_dialog( void);
void incoming_finalize( void);
incoming_list_t *incoming_get_top( void);

#endif
