#ifndef _MAIN_H_
#define _MAIN_H_

#include <windows.h>
#include "common.h"

#define EARTH_CLASSNAME "LuminouSphere"
#define EARTH_WINDOWNAME "LuminouSphere"

#ifdef _MAIN_CPP_
  #define MAIN_EXTERN
#else
  #define MAIN_EXTERN extern
#endif

MAIN_EXTERN HINSTANCE hInst;
MAIN_EXTERN BOOL game_end;
MAIN_EXTERN DWORD current_proc_time;
MAIN_EXTERN DWORD current_draw_time;
MAIN_EXTERN int select_upoint_mode;
MAIN_EXTERN int find_upoint_flg;
MAIN_EXTERN int config_get_coordinate_flg;

extern int screen_saver_mode;
extern HWND hwnd_scr_parent;

typedef enum {
    SMODE_NONE,
    SMODE_CONFIG,
    SMODE_PREVIEW,
    SMODE_SCR,
    SMODE_TEST,
    SMODE_PASSCHANGE,
}SMODE_TYPE;

#endif
