#define _OBJ_CPP_

#include "vce.h"

#include <stdlib.h>
#include <stdio.h>
#include "obj.h"


obj_t *obj_get_start( void)
{
    return obj_start;
}    
/*------------------------------------------------
  
  ------------------------------------------------*/
BOOL obj_initialize(void)
{
    obj_start = NULL;
    obj_num = 0;
    
    return TRUE;
}


/*------------------------------------------------
  IuWFNgNXgɒǉ
  Xg priority ɕԂ悤ɂ
  ------------------------------------------------*/
static void obj_append( obj_t *obj, int priority)
{
    obj_t *pt;
    /* XgɌqB */
    /* ŏʏ */
    if( obj_start == NULL ) {
        obj_start = obj;
        obj->next = NULL;
        obj->prev = NULL;
    }
    else {
        for( pt = obj_start; ; pt = pt->next) {
            /* D揇ʂBɕ */
            if( priority < pt->priority) {
                /* 1ڂŌtBʏ */
                if( pt == obj_start ) {
                    obj_start = obj;
                    obj->next = pt;
                    obj->prev = NULL;
                    pt->prev = obj;
                                        
                }
                else {
                    pt->prev->next = obj;
                    obj->next = pt;
                    obj->prev = pt->prev;
                    pt->prev = obj;
                }
                break;
            }
            /* Xg̍Ō܂ōsĂ܂̂ōŌɒǉB */
            if( pt->next == NULL ) {
                pt->next = obj;
                obj->next = NULL;
                obj->prev = pt;
                break;
            }
        }
    }

    return;
}

obj_t *obj_search( char *name )
{
    obj_t *pt;
    for(pt=obj_start;;pt = pt->next){
        if( strcmp( pt->name, name ) ==0 ){
            return pt;
        }
        if(pt->next == NULL){
            break;
        }
    }
    return NULL;
}


/*------------------------------------------------
  IuWFNg𐶐
  obj.{id,next,prev} ͎IɃZbg
  ̑̓ftHglZbg
  ------------------------------------------------*/
obj_t *obj_new( int priority, int worksize, char *nm )
{
    obj_t *obj;
    
    obj = (obj_t *)malloc(sizeof(obj_t));
    if (obj == NULL) {
        return NULL;
    }
    if( worksize > 0 ) {
        obj->work = malloc( worksize);
        if( obj->work == NULL) {
            free( obj);
            return NULL;
        }
    }
    else {
        obj->work = NULL;
    }
    vce_snprintf( obj->name, sizeof(obj->name), "%s", nm );
    obj->seqnum = obj_num;
    obj->priority = priority;
    obj->x = 0.0;
    obj->y = 0.0;
    obj->z = 0.0;
    obj->dx = 0.0;
    obj->dy = 0.0;
    obj->dz = 0.0;
    obj->mesh_id = -1;
    obj->draw_priority = 0;
    obj->destroy_flg = FALSE;
    obj->motionfunc = NULL;
    obj->drawfunc = NULL;
    obj->destroyfunc = NULL;
    obj->visible = TRUE;
    obj->angle = 0;
    obj->scale_x = 1;
    obj->scale_y = 1;
    obj->rotate_x = 0.0f;
    obj->rotate_y = 0.0f;
    obj->rotate_z = 0.0f;
    obj->d_rotate_x = 0.0f;
    obj->d_rotate_y = 0.0f;
    obj->d_rotate_z = 0.0f;
    obj_append( obj, priority);

    obj_num++;

    return obj;
}



/*------------------------------------------------
  IWFNg
  nꂽ|C^ NULL ɂȂ
  ------------------------------------------------*/
BOOL obj_delete(obj_t *obj)
{
    if (obj == NULL) {
        return FALSE;
    }
    if( obj->destroyfunc) {
        obj->destroyfunc( obj);
    }
    if( obj->work != NULL) {
        free( obj->work);
        obj->work = NULL;
    }
    /* XgȂ */
    if (obj == obj_start) {
        obj_start = obj->next;
    } else {
        obj->prev->next = obj->next;
    }

    if (obj->next != NULL) {
        obj->next->prev = obj->prev;
    }

    free(obj);
    obj = NULL;

    obj_num--;

    return TRUE;
}

void obj_delete_by_id( char *s )
{
    obj_delete( obj_search(s));
}
void obj_delete_by_type( OBJ_TYPE t)
{
    obj_t *obj, *next;
    for (obj = obj_start; obj != NULL; obj = next) {
        next = obj->next;
        if( obj->type == t) {
            obj->destroy_flg = TRUE;
        }
    }
}
/*------------------------------------------------
  SIuWFNg
  ------------------------------------------------*/
void obj_delete_all(void)
{
    obj_t *obj;
    obj_t *next;

    for (obj = obj_start; obj != NULL; obj = next) {
        next = obj->next;
        obj_delete(obj);
    }

    return;
}

/*------------------------------------------------
  I
  ------------------------------------------------*/
void obj_finalize(void)
{
    obj_delete_all();

    return;
}

/*------------------------------------------------
  IuWFNgZbg
  ------------------------------------------------*/
void obj_reset(void)
{
    obj_delete_all();
    obj_initialize();
    
    return;
}
/*------------------------------------------------
  IuWFNg̍XV
  ------------------------------------------------*/
void obj_heartbeat( void)
{
    obj_t *obj;
    static int obj_num_prev = 0;
    obj_t *next;
    
    /* IWFNg̃Xgǂ
       o tOĂ
       o s֐Ă */
    for( obj = obj_start; obj != NULL; obj = next) {
        next = obj->next;
        if (obj->destroy_flg == TRUE) {
            obj_delete(obj);
        } else if( obj->motionfunc != NULL ) {
            obj->motionfunc( obj);
        }
    }

    if (obj_num_prev != obj_num) {
        obj_num_prev = obj_num;
    }
}
