#ifndef _CAMERA_H_
#define _CAMERA_H_

#include <d3d8.h>
#include <d3dx8.h>

#ifdef _CAMERA_CPP_
#define CAMERA_EXTERN
#else
#define CAMERA_EXTERN extern
#endif

CAMERA_EXTERN D3DXMATRIX  mat_view;
CAMERA_EXTERN float cam_eye_x,cam_eye_y, cam_eye_z;
CAMERA_EXTERN float cam_at_x,cam_at_y, cam_at_z;

BOOL camera_init( void);
void camera_move( void);
void camera_automove( void);
void camera_move_to_upoint_init( float lo, float la);
void camera_move_to_upoint( void);

#endif
