#ifndef _CONFIG_H_
#define _CONFIG_H_

HWND create_config( HWND hwnd, int modal_flg);
typedef struct _config_t {
    char keyname[64];
    int int_val;
    char str[1024];
    DWORD type;
    int control_id;
    int control_type;
    int (*checkfunc)( HWND hwnd, HWND dlgitem, struct _config_t *, int, char *);
}config_t;
typedef struct _config_enum_t {
    config_t autologin;
    config_t screensaver;
    config_t nickname;
    config_t longitude1, longitude2, longitude3;
    config_t latitude1, latitude2, latitude3;
    config_t longitude,latitude;
    config_t color_r, color_g, color_b;
    config_t sphere_polygon_rate;
    config_t low_earth_texture;
    config_t hostname;
    config_t port;
    /* not exist in configration dialog */
    config_t last_x, last_y;           
    config_t last_width, last_height; 
    config_t view_wireframe;
    config_t view_rotate;
    config_t view_findroute;
    config_t view_verbose;
    config_t view_automove_viewpoint;
    config_t send_msgdlg_last_x, send_msgdlg_last_y;
    config_t incoming_msgdlg_last_x, incoming_msgdlg_last_y;
    
}config_enum_t;
extern config_enum_t config;
extern int config_dlg_no_error;
int config_read( void);
int config_write( void);
int config_dlg_update( int control_id, char *str, int value);

#endif
