#ifndef _DRAW_H_
#define _DRAW_H_
#ifdef _DRAW_CPP_
#define DRAW_EXTERN
#else
#define DRAW_EXTERN extern
#endif

#include "common.h"
#include <d3d8.h>
#include <d3dx8.h>

#define D3D_RELEASE( o) if( o != NULL) { o->Release(); o = NULL;}

void draw_polygon_set_sec_start( void);
void draw_calc_polygon_rate( void);
void draw_main( void);
void d3d_finalize( void);
BOOL d3d_init( void);
LPDIRECT3DDEVICE8 d3d_get_d3d_dev( void);
void d3d_setlight( float x, float y, float z);
void draw_restore( void);

DRAW_EXTERN int draw_polygon_count;
DRAW_EXTERN int draw_polygon_rate;
DRAW_EXTERN D3DXMATRIX mat_proj;
DRAW_EXTERN D3DLIGHT8 draw_light;
DRAW_EXTERN LPDIRECT3DDEVICE8 d3d_dev;
DRAW_EXTERN int client_area_width;
DRAW_EXTERN int client_area_height;

#endif
