#ifndef _FRAME_H_
#define _FRAME_H_

#ifdef _FRAME_CPP_
#define FRAME_EXTERN
#else
#define FRAME_EXTERN extern
#endif
#include <windows.h>

FRAME_EXTERN int no_draw_count;
FRAME_EXTERN int draw_count;
FRAME_EXTERN int frame_count;
FRAME_EXTERN int frame_rate;
FRAME_EXTERN LONGLONG freq_perfcount;     // performance counter frequency

#include <windows.h>
#include "common.h"
BOOL frame_initialize(void);
BOOL frame_is_refresh_time(void);
void frame_reset( void);
void frame_sleep( void);
void frame_set_sec_start( void);
void frame_calc_frame_rate( void);
void frame_set_next_refresh( void);

#endif

