#ifndef _INPUT_H_
#define _INPUT_H_
#ifdef _INPUT_CPP_
#define INPUT_EXTERN
#else
#define INPUT_EXTERN extern
#endif

#include "common.h"
#define INPUT_MOUSE_BUFF_MAX 128
INPUT_EXTERN HANDLE input_mouse_event;

/* input buffer */
INPUT_EXTERN char input_keyboard_data[256];
INPUT_EXTERN char input_keyboard_data_new_pressed[256];
INPUT_EXTERN int input_mouse_move_x;
INPUT_EXTERN int input_mouse_move_y;
INPUT_EXTERN int input_mouse_lbutton;
INPUT_EXTERN int input_mouse_lbutton_new_pressed;
INPUT_EXTERN int input_mouse_rbutton;
INPUT_EXTERN int input_mouse_rbutton_new_pressed;
INPUT_EXTERN int mouse_x;
INPUT_EXTERN int mouse_y;
INPUT_EXTERN BOOL input_mouse_move_flg_x;
INPUT_EXTERN BOOL input_mouse_move_flg_y;



BOOL input_init( void);
void input_finalize( void);
void input_mouse_loop( void);
void input_keyboard_loop( void);
void input_mouse_set_acquire( void);
void input_keyboard_set_acquire( void);

#endif
