#ifndef _MATH_H_
#define _MATH_H_

int sign( float a, float b );
float sphere_distance( float x1, float y1, float x2, float y2, float h );
D3DXVECTOR3 random_sphere_vec( D3DXVECTOR3 v, float radius );
void earth_get_v_lolah( D3DXVECTOR3 *v, float lo, float la, float h_km );
float distance( float x1, float y1, float x2, float y2 );
int calc_cursor_intersect( int x, int y, D3DXVECTOR3 *ret);
void earth_get_lolah( float x, float y, float z, float *lo, float *la);
void earth_conv_rad_to_hms( float r, int *h, int *min, int *sec);

#endif
