#ifndef _MESH_H_
#define _MESH_H_

#include <d3d8.h>
#include <d3dx8.h>

typedef struct _mesh_t {
    int id;           /* identifier for access easily */
    int num;          /* number of material */
    D3DMATERIAL8 *materials;
    LPDIRECT3DTEXTURE8 *textures;
    LPD3DXMESH mesh;
}mesh_t;

BOOL mesh_init( void);
void mesh_finalize( void);
mesh_t *mesh_get_mesh_from_id( int id);

#endif
