#ifndef _NET_H_
#define _NET_H_

int net_init( void );
void net_poll( void );
int net_logout( void);
int net_sendmsg( unsigned int serial, char *str);
int net_announce( char *pass, char *msg);

typedef enum
{
    NET_INIT = 0,
    NET_CONNECT,
    NET_ESTABLISHED,
    NET_WAITLOGIN, 
    NET_LOGIN, /* Please set this state after deciding your position */
    NETSTATE_NUM,
} NETSTATE;

#define INIT_LONGITUDE (-9999)
extern int my_longitude;
extern int my_latitude;
extern NETSTATE netstat;
extern int user_num;
extern unsigned int my_serial;
#endif
