#ifndef _WIN_H_
#define _WIN_H_

#include <windows.h>
#include "common.h"

#define SCREEN_WIDTH 640
#define SCREEN_HEIGHT 480
enum {
    WINDOW_MODE,
    FULL_SCREEN
};

#ifdef _WIN_CPP_
  #define WIN_EXTERN
#else
  #define WIN_EXTERN extern
#endif


WIN_EXTERN HWND hWnd;
WIN_EXTERN HWND hWnd_config_dlg;
WIN_EXTERN HWND hWnd_version_dlg;
WIN_EXTERN int window_height;
WIN_EXTERN int window_width;
WIN_EXTERN int gScreen_mode;
WIN_EXTERN BOOL gActive;
WIN_EXTERN HMENU hMenu;

int window_init( void);
void window_menu_update( void);


#endif
